Index: kaffe/kaffevm/exception.c
===================================================================
RCS file: /home/cvspublic/kaffe/kaffe/kaffevm/exception.c,v
retrieving revision 1.9
diff -u -r1.9 exception.c
--- exception.c	1998/12/02 22:58:31	1.9
+++ exception.c	1998/12/04 17:34:40
@@ -66,7 +66,7 @@
  * STACK_LOW to have enough space to create the StackOverflowError --- if
  * the error is caught, we set it back to STACK_HIGH.
  */
-int needOnStack;
+int needOnStack = STACK_HIGH;
 
 /*
  * Throw an internal exception.
@@ -235,6 +235,7 @@
 			/* Handler found - dispatch exception */
 			if (einfo.handler != 0) {
 				unhand(ct)->exceptObj = 0;
+				needOnStack = STACK_HIGH;
 				CALL_KAFFE_EXCEPTION(frame, einfo, eobj);
 			}
 
Index: kaffe/kaffevm/jit/machine.c
===================================================================
RCS file: /home/cvspublic/kaffe/kaffe/kaffevm/jit/machine.c,v
retrieving revision 1.10
diff -u -r1.10 machine.c
--- machine.c	1998/12/02 22:58:34	1.10
+++ machine.c	1998/12/04 17:34:41
@@ -42,6 +42,7 @@
 #include "external.h"
 #include "soft.h"
 #include "jni.h"
+#include "thread.h"
 
 /*
  * Define information about this engine.
@@ -117,6 +118,22 @@
 void	cancelNoWriteback(void);
 jlong	currentTime(void);
 
+static void checkStackOverflow(void)
+{
+	Hjava_lang_Throwable* overflow;
+
+	overflow = (*Kaffe_ThreadInterface.checkStack)(needOnStack);
+	if (overflow != 0) {
+		if (needOnStack == STACK_LOW) {
+			fprintf(stderr, 
+				"Panic: unhandled StackOverflowError()\n");
+			ABORT();
+		}
+		needOnStack = STACK_LOW;
+		throwException(overflow);
+	}
+}
+
 /*
  * Translate a method into native code.
  *
@@ -212,6 +229,9 @@
 
 	start_basic_block();
 	start_function();
+
+	call_soft(checkStackOverflow);
+
 	monitor_enter();
 	if (IS_STARTOFBASICBLOCK(0)) {
 		end_basic_block();
